Index: branches/1.3/gui/scripts/vtkvolumeviewer.tcl
===================================================================
--- branches/1.3/gui/scripts/vtkvolumeviewer.tcl	(revision 4828)
+++ branches/1.3/gui/scripts/vtkvolumeviewer.tcl	(revision 4848)
@@ -1,5 +1,6 @@
 # -*- mode: tcl; indent-tabs-mode: nil -*- 
-# ----------------------------------------------------------------------
-#  COMPONENT: vtkvolumeviewer - Vtk volume viewer
+
+# ----------------------------------------------------------------------
+#  COMPONENT: VtkVolumeViewer - Vtk volume viewer
 #
 #  It connects to the Vtk server running on a rendering farm,
@@ -7,5 +8,5 @@
 # ======================================================================
 #  AUTHOR:  Michael McLennan, Purdue University
-#  Copyright (c) 2004-2014  HUBzero Foundation, LLC
+#  Copyright (c) 2004-2012  HUBzero Foundation, LLC
 #
 #  See the file "license.terms" for information on usage and
@@ -62,11 +63,22 @@
     public method scale {args}
 
-    private method GetDatasetsWithComponent { cname } 
-
-    private variable _volcomponents   ; # Array of components found 
-    private variable _componentsList   ; # List of component names
+    protected method Connect {}
+    protected method CurrentDatasets {args}
+    protected method Disconnect {}
+    protected method DoResize {}
+    protected method DoReseed {}
+    protected method DoRotate {}
+    protected method AdjustSetting {what {value ""}}
+    protected method InitSettings { args  }
+    protected method Pan {option x y}
+    protected method Pick {x y}
+    protected method Rebuild {}
+    protected method ReceiveDataset { args }
+    protected method ReceiveImage { args }
+    protected method ReceiveLegend { colormap title vmin vmax size }
+    protected method Rotate {option x y}
+    protected method Zoom {option}
 
     # The following methods are only used by this class.
-    private method AdjustSetting {what {value ""}}
     private method BuildAxisTab {}
     private method BuildCameraTab {}
@@ -74,46 +86,24 @@
     private method BuildCutplaneTab {}
     private method BuildDownloadPopup { widget command } 
-    private method BuildViewTab {}
     private method BuildVolumeTab {}
     private method DrawLegend {}
-    private method ChangeColormap { dataobj comp color }
     private method Combo { option }
-    private method Connect {}
-    private method CurrentDatasets {args}
-    private method Disconnect {}
-    private method DoResize {}
-    private method DoRotate {}
     private method EnterLegend { x y } 
     private method EventuallyResize { w h } 
-    private method EventuallyRequestLegend {} 
+    private method EventuallyReseed { numPoints } 
     private method EventuallyRotate { q } 
     private method EventuallySetCutplane { axis args } 
     private method GetImage { args } 
     private method GetVtkData { args } 
-    private method InitSettings { args  }
     private method IsValidObject { dataobj } 
     private method LeaveLegend {}
-    private method MotionLegend { x y }
-    private method Pan {option x y}
+    private method MotionLegend { x y } 
     private method PanCamera {}
-    private method Pick {x y}
-    private method QuaternionToView { q } { 
-        foreach { _view(-qw) _view(-qx) _view(-qy) _view(-qz) } $q break
-    }
-    private method Rebuild {}
-    private method ReceiveDataset { args }
-    private method ReceiveImage { args }
-    private method ReceiveLegend { colormap title vmin vmax size }
     private method RequestLegend {}
     private method SetColormap { dataobj comp }
-    private method Rotate {option x y}
+    private method ChangeColormap { dataobj comp color }
     private method SetLegendTip { x y }
     private method SetObjectStyle { dataobj comp } 
-    private method SetOrientation { side }
     private method Slice {option args} 
-    private method ViewToQuaternion {} { 
-        return [list $_view(-qw) $_view(-qx) $_view(-qy) $_view(-qz)]
-    }
-    private method Zoom {option}
 
     private variable _arcball ""
@@ -139,4 +129,5 @@
     private variable _start 0
     private variable _title ""
+    private variable _seeds
 
     common _downloadPopup;              # download options from popup
@@ -145,4 +136,5 @@
     private variable _height 0
     private variable _resizePending 0
+    private variable _reseedPending 0
     private variable _rotatePending 0
     private variable _cutplanePending 0
@@ -151,7 +143,5 @@
     private variable _curFldName ""
     private variable _curFldLabel ""
-    private variable _colorMode "scalar"; #  Mode of colormap (vmag or scalar)
-    private variable _cutplaneCmd "cutplane"
-    private variable _allowMultiComponent 0
+    private variable _colorMode "vmag";#  Mode of colormap (vmag or scalar)
 }
 
@@ -168,6 +158,4 @@
     set _serverType "vtkvis"
 
-    EnableWaitDialog 900
-
     # Rebuild event
     $_dispatcher register !rebuild
@@ -178,4 +166,8 @@
     $_dispatcher dispatch $this !resize "[itcl::code $this DoResize]; list"
 
+    # Reseed event
+    $_dispatcher register !reseed
+    $_dispatcher dispatch $this !reseed "[itcl::code $this DoReseed]; list"
+
     # Rotate event
     $_dispatcher register !rotate
@@ -189,15 +181,15 @@
     $_dispatcher register !xcutplane
     $_dispatcher dispatch $this !xcutplane \
-        "[itcl::code $this AdjustSetting -xcutplaneposition]; list"
+        "[itcl::code $this AdjustSetting cutplane-xposition]; list"
 
     # Y-Cutplane event
     $_dispatcher register !ycutplane
     $_dispatcher dispatch $this !ycutplane \
-        "[itcl::code $this AdjustSetting -ycutplaneposition]; list"
+        "[itcl::code $this AdjustSetting cutplane-yposition]; list"
 
     # Z-Cutplane event
     $_dispatcher register !zcutplane
     $_dispatcher dispatch $this !zcutplane \
-        "[itcl::code $this AdjustSetting -zcutplaneposition]; list"
+        "[itcl::code $this AdjustSetting cutplane-zposition]; list"
 
     #
@@ -210,42 +202,40 @@
     # Initialize the view to some default parameters.
     array set _view {
-        -ortho           0
-        -qw              0.853553
-        -qx              -0.353553
-        -qy              0.353553
-        -qz              0.146447
-        -xpan            0
-        -ypan            0
-        -zoom            1.0 
+        qw              0.853553
+        qx              -0.353553
+        qy              0.353553
+        qz              0.146447
+        zoom            1.0 
+        xpan            0
+        ypan            0
+        ortho           0
     }
     set _arcball [blt::arcball create 100 100]
-    $_arcball quaternion [ViewToQuaternion]
+    set q [list $_view(qw) $_view(qx) $_view(qy) $_view(qz)]
+    $_arcball quaternion $q
 
     array set _settings {
-        -axesvisible                    1
-        -axisflymode                    static
-        -axislabels                     1
-        -axisminorticks                 1
-        -background                     black
-        -color                          BCGYR
-        -cutplanelighting               1
-        -cutplaneopacity                100
-        -cutplanesvisible               0
-        -legendvisible                  1
-        -volumelighting                 1
-        -volumematerial                 80
-        -volumeopacity                  50
-        -volumeoutline                  0
-        -volumequality                  80
-        -volumevisible                  1
-        -xcutplaneposition              50
-        -xcutplanevisible               1
-        -xgrid                          0
-        -ycutplaneposition              50
-        -ycutplanevisible               1
-        -ygrid                          0
-        -zcutplaneposition              50
-        -zcutplanevisible               1
-        -zgrid                          0
+        axis-xgrid              0
+        axis-ygrid              0
+        axis-zgrid              0
+        axesVisible             1
+        axisLabels              1
+        cutplaneEdges           0
+        cutplane-xvisible       1
+        cutplane-yvisible       1
+        cutplane-zvisible       1
+        cutplane-xposition      50
+        cutplane-yposition      50
+        cutplane-zposition      50
+        cutplaneVisible         0
+        cutplaneLighting        1
+        cutplaneWireframe       0
+        cutplane-opacity        100
+        volumeLighting          1
+        volume-material         80
+        volume-opacity          40
+        volume-quality          50
+        volumeVisible           1
+        legendVisible           1
     }
 
@@ -326,6 +316,6 @@
             -onimage [Rappture::icon volume-on] \
             -offimage [Rappture::icon volume-off] \
-            -variable [itcl::scope _settings(-volumevisible)] \
-            -command [itcl::code $this AdjustSetting -volumevisible] 
+            -variable [itcl::scope _settings(volumeVisible)] \
+            -command [itcl::code $this AdjustSetting volumeVisible] 
     }
     $itk_component(volume) select
@@ -338,6 +328,6 @@
             -onimage [Rappture::icon cutbutton] \
             -offimage [Rappture::icon cutbutton] \
-            -variable [itcl::scope _settings(-cutplanesvisible)] \
-            -command [itcl::code $this AdjustSetting -cutplanesvisible] 
+            -variable [itcl::scope _settings(cutplaneVisible)] \
+            -command [itcl::code $this AdjustSetting cutplaneVisible] 
     }
     Rappture::Tooltip::for $itk_component(cutplane) \
@@ -347,5 +337,4 @@
 
     if { [catch {
-        BuildViewTab
         BuildVolumeTab
         BuildCutplaneTab
@@ -355,6 +344,6 @@
         puts stderr errs=$errs
     }
-
     # Legend
+
     set _image(legend) [image create photo]
     itk_component add legend {
@@ -382,5 +371,11 @@
     bind $itk_component(view) <ButtonRelease-1> \
         [itcl::code $this Rotate release %x %y]
-
+    bind $itk_component(view) <Configure> \
+        [itcl::code $this EventuallyResize %w %h]
+
+    if 0 {
+    bind $itk_component(view) <Configure> \
+        [itcl::code $this EventuallyResize %w %h]
+    }
     # Bindings for panning via mouse
     bind $itk_component(view) <ButtonPress-2> \
@@ -430,4 +425,5 @@
     eval itk_initialize $args
     Connect
+    update
 }
 
@@ -457,5 +453,6 @@
 
 itcl::body Rappture::VtkVolumeViewer::DoRotate {} {
-    SendCmd "camera orient [ViewToQuaternion]" 
+    set q [list $_view(qw) $_view(qx) $_view(qy) $_view(qz)]
+    SendCmd "camera orient $q" 
     set _rotatePending 0
 }
@@ -471,8 +468,9 @@
 }
 
-itcl::body Rappture::VtkVolumeViewer::EventuallyRequestLegend {} {
-    if { !$_legendPending } {
-        set _legendPending 1
-        $_dispatcher event -idle !legend
+itcl::body Rappture::VtkVolumeViewer::EventuallyReseed { numPoints } {
+    set _numSeeds $numPoints
+    if { !$_reseedPending } {
+        set _reseedPending 1
+        $_dispatcher event -after 600 !reseed
     }
 }
@@ -481,5 +479,5 @@
 
 itcl::body Rappture::VtkVolumeViewer::EventuallyRotate { q } {
-    QuaternionToView $q
+    foreach { _view(qw) _view(qx) _view(qy) _view(qz) } $q break
     if { !$_rotatePending } {
         set _rotatePending 1
@@ -504,7 +502,4 @@
 # ----------------------------------------------------------------------
 itcl::body Rappture::VtkVolumeViewer::add {dataobj {settings ""}} {
-    if { ![IsValidObject $dataobj] } {
-        return;                         # Ignore invalid objects.
-    }
     array set params {
         -color auto
@@ -649,13 +644,5 @@
 # ----------------------------------------------------------------------
 itcl::body Rappture::VtkVolumeViewer::scale {args} {
-    array unset _limits
-    array unset _volcomponents
-    set _componentsList ""
-
     foreach dataobj $args {
-        if { ![$dataobj isvalid] } {
-            continue;                     # Object doesn't contain valid data.
-        }
-        # Determine limits for each axis.
         foreach axis { x y z } {
             set lim [$dataobj limits $axis]
@@ -674,5 +661,4 @@
             set _limits($axis) [list $amin $amax]
         }
-        # Determine limits for each field.
         foreach { fname lim } [$dataobj fieldlimits] {
             if { ![info exists _limits($fname)] } {
@@ -689,26 +675,4 @@
             }
             set _limits($fname) [list $fmin $fmax]
-        }
-        # Get limits for each component.
-        foreach cname [$dataobj components] {
-            if { ![info exists _volcomponents($cname)] } {
-                lappend _componentsList $cname
-            }
-            lappend _volcomponents($cname) $dataobj-$cname
-            array unset limits
-            array set limits [$dataobj valueLimits $cname]
-            if { ![info exists _limits($cname)] } {
-                set _limits($cname) $limits(v)
-                continue
-            }
-            foreach {min max} $limits(v) break
-            foreach {vmin vmax} $_limits($cname) break
-            if { $vmin > $min } {
-                set vmin $min
-            }
-            if { $vmax < $max } {
-                set vmax $max
-            }
-            set _limits($cname) [list $vmin $vmax]
         }
     }
@@ -787,5 +751,5 @@
         if { $_reportClientInfo }  {
             # Tell the server the viewer, hub, user and session.
-            # Do this immediately on connect before buffering any commands
+            # Do this immediately on connect before buffing any commands
             global env
 
@@ -845,4 +809,5 @@
     $_dispatcher cancel !rebuild
     $_dispatcher cancel !resize
+    $_dispatcher cancel !reseed
     $_dispatcher cancel !rotate
     $_dispatcher cancel !xcutplane
@@ -855,12 +820,7 @@
     array unset _data 
     array unset _colormaps 
+    array unset _seeds 
     array unset _dataset2style 
     array unset _obj2datasets 
-
-    set _resizePending 0
-    set _rotatePending 0
-    set _cutplanePending 0
-    set _legendPending 0
-    set _reset 1
 }
 
@@ -883,11 +843,12 @@
     if { $info(-type) == "image" } {
         if 0 {
-            set f [open "last.ppm" "w"]
-            fconfigure $f -encoding binary
-            puts -nonewline $f $bytes
+            set f [open "last.ppm" "w"] 
+            puts $f $bytes
             close $f
         }
         $_image(plot) configure -data $bytes
-        #puts stderr "[clock format [clock seconds]]: received image [image width $_image(plot)]x[image height $_image(plot)] image>"
+        set time [clock seconds]
+        set date [clock format $time]
+        #puts stderr "$date: received image [image width $_image(plot)]x[image height $_image(plot)] image>"        
         if { $_start > 0 } {
             set finish [clock clicks -milliseconds]
@@ -954,7 +915,7 @@
 # ----------------------------------------------------------------------
 itcl::body Rappture::VtkVolumeViewer::Rebuild {} {
+    update
     set w [winfo width $itk_component(view)]
     set h [winfo height $itk_component(view)]
-
     if { $w < 2 || $h < 2 } {
         $_dispatcher event -idle !rebuild
@@ -969,16 +930,15 @@
     set _legendPending 1
 
-    if { $_width != $w || $_height != $h || $_reset } {
+    if { $_reset } {
         set _width $w
         set _height $h
         $_arcball resize $w $h
         DoResize
-    }
-    if { $_reset } {
         #
         # Reset the camera and other view parameters
         #
-        $_arcball quaternion [ViewToQuaternion]
-        if {$_view(-ortho)} {
+        set q [list $_view(qw) $_view(qx) $_view(qy) $_view(qz)]
+        $_arcball quaternion $q
+        if {$_view(ortho)} {
             SendCmd "camera mode ortho"
         } else {
@@ -986,13 +946,11 @@
         }
         DoRotate
+        InitSettings axis-xgrid axis-ygrid axis-zgrid axisFlyMode \
+            axesVisible axisLabels
         PanCamera
-        set _first ""
-        InitSettings -background \
-            -xgrid -ygrid -zgrid -axisflymode \
-            -axesvisible -axislabels -axisminorticks
-        StopBufferingCommands
-        SendCmd "imgflush"
-        StartBufferingCommands
-     }
+    }
+    set _first ""
+
+    SendCmd "imgflush"
     set _first ""
 
@@ -1007,10 +965,4 @@
             if { ![info exists _datasets($tag)] } {
                 set bytes [$dataobj vtkdata $comp]
-		if 0 { 
-                    set f [open /tmp/vtkvolume.vtk "w"]
-                    fconfigure $f -translation binary -encoding binary
-                    puts -nonewline $f $bytes
-                    close $f
-		}
                 set length [string length $bytes]
                 if { $_reportClientInfo }  {
@@ -1024,7 +976,7 @@
                     lappend info "dataset_size"  $length
                     lappend info "dataset_tag"   $tag
-                    SendCmd "clientinfo [list $info]"
-                }
-                SendCmd "dataset add $tag data follows $length"
+                    SendCmd [list "clientinfo" $info]
+                }
+                append _outbuf "dataset add $tag data follows $length\n"
                 append _outbuf $bytes
                 set _datasets($tag) 1
@@ -1033,5 +985,5 @@
             lappend _obj2datasets($dataobj) $tag
             if { [info exists _obj2ovride($dataobj-raise)] } {
-                SendCmd "volume visible 1 $tag"
+                SendCmd "dataset visible 1 $tag"
             }
             break
@@ -1047,9 +999,9 @@
             set label [$_first hints ${axis}label]
             if { $label != "" } {
-                SendCmd [list axis name $axis $label]
+                SendCmd "axis name $axis $label"
             }
             set units [$_first hints ${axis}units]
             if { $units != "" } {
-                SendCmd [list axis units $axis $units]
+                SendCmd "axis units $axis $units"
             }
         }
@@ -1066,5 +1018,5 @@
                     [$_first fieldinfo $fname] break
                 # Only scalar fields are valid
-                if {$_allowMultiComponent || $components == 1} {
+                if {$components == 1} {
                     $itk_component(field) choices insert end "$fname" "$label"
                     $itk_component(fieldmenu) add radiobutton -label "$label" \
@@ -1086,12 +1038,11 @@
     }
 
-    InitSettings -color \
-        -volumematerial \
-        -volumelighting -volumeopacity -volumequality -volumeoutline -volumevisible \
-        -cutplanesvisible \
-        -xcutplaneposition -ycutplaneposition -zcutplaneposition \
-        -xcutplanevisible -ycutplanevisible -zcutplanevisible
+    InitSettings volume-palette volume-material volume-quality volumeVisible \
+        cutplaneVisible \
+        cutplane-xposition cutplane-yposition cutplane-zposition \
+        cutplane-xvisible cutplane-yvisible cutplane-zvisible
 
     if { $_reset } {
+        InitSettings volumeLighting
         Zoom reset
         set _reset 0
@@ -1160,20 +1111,20 @@
     switch -- $option {
         "in" {
-            set _view(-zoom) [expr {$_view(-zoom)*1.25}]
-            SendCmd "camera zoom $_view(-zoom)"
+            set _view(zoom) [expr {$_view(zoom)*1.25}]
+            SendCmd "camera zoom $_view(zoom)"
         }
         "out" {
-            set _view(-zoom) [expr {$_view(-zoom)*0.8}]
-            SendCmd "camera zoom $_view(-zoom)"
+            set _view(zoom) [expr {$_view(zoom)*0.8}]
+            SendCmd "camera zoom $_view(zoom)"
         }
         "reset" {
             array set _view {
-                -qw      0.853553
-                -qx      -0.353553
-                -qy      0.353553
-                -qz      0.146447
-                -xpan    0
-                -ypan    0
-                -zoom    1.0
+                qw      0.853553
+                qx      -0.353553
+                qy      0.353553
+                qz      0.146447
+                zoom    1.0
+                xpan   0
+                ypan   0
             }
             if { $_first != "" } {
@@ -1183,5 +1134,6 @@
                 }
             }
-            $_arcball quaternion [ViewToQuaternion]
+            set q [list $_view(qw) $_view(qx) $_view(qy) $_view(qz)]
+            $_arcball quaternion $q
             DoRotate
             SendCmd "camera reset"
@@ -1191,8 +1143,9 @@
 
 itcl::body Rappture::VtkVolumeViewer::PanCamera {} {
-    set x $_view(-xpan)
-    set y $_view(-ypan)
+    set x $_view(xpan)
+    set y $_view(ypan)
     SendCmd "camera pan $x $y"
 }
+
 
 # ----------------------------------------------------------------------
@@ -1269,6 +1222,6 @@
             set x [expr $x / double($w)]
             set y [expr $y / double($h)]
-            set _view(-xpan) [expr $_view(-xpan) + $x]
-            set _view(-ypan) [expr $_view(-ypan) + $y]
+            set _view(xpan) [expr $_view(xpan) + $x]
+            set _view(ypan) [expr $_view(ypan) + $y]
             PanCamera
             return
@@ -1292,6 +1245,6 @@
             set _click(x) $x
             set _click(y) $y
-            set _view(-xpan) [expr $_view(-xpan) - $dx]
-            set _view(-ypan) [expr $_view(-ypan) - $dy]
+            set _view(xpan) [expr $_view(xpan) - $dx]
+            set _view(ypan) [expr $_view(ypan) - $dy]
             PanCamera
         }
@@ -1315,7 +1268,7 @@
 itcl::body Rappture::VtkVolumeViewer::InitSettings { args } {
     foreach spec $args {
-        if { [info exists _settings($_first${spec})] } {
+        if { [info exists _settings($_first-$spec)] } {
             # Reset global setting with dataobj specific setting
-            set _settings($spec) $_settings($_first${spec})
+            set _settings($spec) $_settings($_first-$spec)
         }
         AdjustSetting $spec
@@ -1335,31 +1288,8 @@
     }
     switch -- $what {
-        "-background" {
-            set bgcolor [$itk_component(background) value]
-            set _settings($what) $bgcolor
-	    array set fgcolors {
-		"black" "white"
-		"white" "black"
-		"grey"	"black"
-	    }
-            configure -plotbackground $bgcolor \
-		-plotforeground $fgcolors($bgcolor)
-	    $itk_component(view) delete "legend"
-	    DrawLegend
-        }
-        "-volumeoutline" {
-            set bool $_settings($what)
-            SendCmd "outline visible 0"
-            foreach tag [CurrentDatasets -visible] {
-                SendCmd "outline visible $bool $tag"
-            }
-        }
-        "-legendvisible" {
-            set bool $_settings($what)
-        }
-        "-volumevisible" {
-            set bool $_settings($what)
-            foreach tag [CurrentDatasets -visible] {
-                SendCmd "volume visible $bool $tag"
+        "volumeVisible" {
+            set bool $_settings(volumeVisible)
+            foreach dataset [CurrentDatasets -visible] {
+                SendCmd "volume visible $bool $dataset"
             }
             if { $bool } {
@@ -1371,53 +1301,42 @@
             }
         }
-        "-volumematerial" {
-            set val $_settings($what)
+        "volume-material" {
+            set val $_settings(volume-material)
             set diffuse [expr {0.01*$val}]
             set specular [expr {0.01*$val}]
             #set power [expr {sqrt(160*$val+1.0)}]
             set power [expr {$val+1.0}]
-            foreach tag [CurrentDatasets -visible] {
-                SendCmd "volume shading diffuse $diffuse $tag"
-                SendCmd "volume shading specular $specular $power $tag"
-            }
-        }
-        "-volumelighting" {
-            set bool $_settings($what)
-            foreach tag [CurrentDatasets -visible] {
-                SendCmd "volume lighting $bool $tag"
-            }
-        }
-        "-volumeopacity" {
-            set val $_settings($what)
+            foreach dataset [CurrentDatasets -visible] {
+                SendCmd "volume shading diffuse $diffuse $dataset"
+                SendCmd "volume shading specular $specular $power $dataset"
+            }
+        }
+        "volumeLighting" {
+            set bool $_settings(volumeLighting)
+            foreach dataset [CurrentDatasets -visible] {
+                SendCmd "volume lighting $bool $dataset"
+            }
+        }
+        "volume-quality" {
+            set val $_settings(volume-quality)
             set val [expr {0.01*$val}]
-            foreach tag [CurrentDatasets -visible] {
-                SendCmd "volume opacity $val $tag"
-            }
-        }
-        "-volumequality" {
-            set val $_settings($what)
-            set val [expr {0.01*$val}]
-            foreach tag [CurrentDatasets -visible] {
-                SendCmd "volume quality $val $tag"
-            }
-        }
-        "-axesvisible" {
-            set bool $_settings($what)
+            foreach dataset [CurrentDatasets -visible] {
+                SendCmd "volume quality $val $dataset"
+            }
+        }
+        "axesVisible" {
+            set bool $_settings(axesVisible)
             SendCmd "axis visible all $bool"
         }
-        "-axislabels" {
-            set bool $_settings($what)
+        "axisLabels" {
+            set bool $_settings(axisLabels)
             SendCmd "axis labels all $bool"
         }
-        "-axisminorticks" {
-            set bool $_settings($what)
-            SendCmd "axis minticks all $bool"
-        }
-        "-xgrid" - "-ygrid" - "-zgrid" {
-            set axis [string range $what 1 1]
+        "axis-xgrid" - "axis-ygrid" - "axis-zgrid" {
+            set axis [string range $what 5 5]
             set bool $_settings($what)
             SendCmd "axis grid $axis $bool"
         }
-        "-axisflymode" {
+        "axisFlyMode" {
             set mode [$itk_component(axismode) value]
             set mode [$itk_component(axismode) translate $mode]
@@ -1425,36 +1344,37 @@
             SendCmd "axis flymode $mode"
         }
-        "-cutplanesvisible" {
+        "cutplaneEdges" {
             set bool $_settings($what)
             foreach dataset [CurrentDatasets -visible] {
-                SendCmd "$_cutplaneCmd visible $bool $dataset"
-            }
-        }
-        "-cutplanelighting" {
+                SendCmd "cutplane edges $bool $dataset"
+            }
+        }
+        "cutplaneVisible" {
             set bool $_settings($what)
             foreach dataset [CurrentDatasets -visible] {
-                if {$_cutplaneCmd != "imgcutplane"} {
-                    SendCmd "$_cutplaneCmd lighting $bool $dataset"
-                } else {
-                    if {$bool} {
-                        set ambient 0.0
-                        set diffuse 1.0
-                    } else {
-                        set ambient 1.0
-                        set diffuse 0.0
-                    }
-                    SendCmd "imgcutplane material $ambient $diffuse $dataset"
-                }
-            }
-        }
-        "-cutplaneopacity" {
+                SendCmd "cutplane visible $bool $dataset"
+            }
+        }
+        "cutplaneWireframe" {
+            set bool $_settings($what)
+            foreach dataset [CurrentDatasets -visible] {
+                SendCmd "cutplane wireframe $bool $dataset"
+            }
+        }
+        "cutplaneLighting" {
+            set bool $_settings($what)
+            foreach dataset [CurrentDatasets -visible] {
+                SendCmd "cutplane lighting $bool $dataset"
+            }
+        }
+        "cutplane-opacity" {
             set val $_settings($what)
             set sval [expr { 0.01 * double($val) }]
             foreach dataset [CurrentDatasets -visible] {
-                SendCmd "$_cutplaneCmd opacity $sval $dataset"
-            }
-        }
-        "-xcutplanevisible" - "-ycutplanevisible" - "-zcutplanevisible" {
-            set axis [string range $what 1 1]
+                SendCmd "cutplane opacity $sval $dataset"
+            }
+        }
+        "cutplane-xvisible" - "cutplane-yvisible" - "cutplane-zvisible" {
+            set axis [string range $what 9 9]
             set bool $_settings($what)
             if { $bool } {
@@ -1466,39 +1386,44 @@
             }
             foreach dataset [CurrentDatasets -visible] {
-                SendCmd "$_cutplaneCmd axis $axis $bool $dataset"
-            }
-        }
-        "-xcutplaneposition" - "-ycutplaneposition" - "-zcutplaneposition" {
-            set axis [string range $what 1 1]
+                SendCmd "cutplane axis $axis $bool $dataset"
+            }
+        }
+        "cutplane-xposition" - "cutplane-yposition" - "cutplane-zposition" {
+            set axis [string range $what 9 9]
             set pos [expr $_settings($what) * 0.01]
             foreach dataset [CurrentDatasets -visible] {
-                SendCmd "$_cutplaneCmd slice ${axis} ${pos} $dataset"
+                SendCmd "cutplane slice ${axis} ${pos} $dataset"
             }
             set _cutplanePending 0
         }
-        "-color" {
-            set color [$itk_component(colormap) value]
-            set _settings($what) $color
+        "volume-palette" {
+            set palette [$itk_component(palette) value]
+            set _settings(volume-palette) $palette
             foreach dataset [CurrentDatasets -visible $_first] {
                 foreach {dataobj comp} [split $dataset -] break
-                ChangeColormap $dataobj $comp $color
+                ChangeColormap $dataobj $comp $palette
             }
             set _legendPending 1
         }
-        "-field" {
+        "volume-palette" {
+            set palette [$itk_component(palette) value]
+            set _settings(volume-palette) $palette
+            foreach dataset [CurrentDatasets -visible $_first] {
+                foreach {dataobj comp} [split $dataset -] break
+                ChangeColormap $dataobj $comp $palette
+            }
+            set _legendPending 1
+        }
+        "field" {
             set label [$itk_component(field) value]
             set fname [$itk_component(field) translate $label]
-            set _settings($what) $fname
+            set _settings(field) $fname
             if { [info exists _fields($fname)] } {
                 foreach { label units components } $_fields($fname) break
-                if { !$_allowMultiComponent && $components > 1 } {
+                if { $components > 1 } {
                     puts stderr "Can't use a vector field in a volume"
                     return
                 } else {
-                    if { $components > 1 } {
-                        set _colorMode vmag
-                    } else {
-                        set _colorMode scalar
-                    }
+                    set _colorMode scalar
                 }
                 set _curFldName $fname
@@ -1509,6 +1434,6 @@
             }
             foreach dataset [CurrentDatasets -visible $_first] {
-                #SendCmd "$_cutplaneCmd colormode $_colorMode $_curFldName $dataset"
-                SendCmd "dataset scalar $_curFldName $dataset"
+                #SendCmd "volume colormode $_colorMode ${fname} $dataset"
+                SendCmd "cutplane colormode $_colorMode ${fname} $dataset"
             }
             SendCmd "camera reset"
@@ -1542,6 +1467,5 @@
         if { [info exists _dataset2style($dataset)] } {
             SendCmdNoWait \
-                "legend2 $_dataset2style($dataset) $w $h"
-                #"legend $_dataset2style($dataset) $_colorMode $_curFldName {} $w $h 0"
+                "legend $_dataset2style($dataset) $_colorMode $_curFldName {} $w $h 0"
             break;
         }
@@ -1570,4 +1494,5 @@
         -color BCGYR
         -levels 6
+        -opacity 1.0
     }
     set tag $dataobj-$comp
